; blink.asm - blink RS232 tester TxD LED
; author Neil Franklin, last modification 2008.09.13

; need fuses, fast external quarz osc, max stable startup
; FF: 7:BODLVL=1, 6:BOD=1 (disable), 54:SUT=11, 3210:CKSEL=1111 (ext resonator)
; D9: 7:OCDEN=1 (dis), 6:JTAGEN=1 (dis), 5:SPIEN=0 (en), 4:CKOPT=1
;     3:EESAVE=1 (not preserve), 21:BOOTSZ=00, 0:BOOTRST=1 


  .include "m32def.inc"

  .cseg
  .org $0000

  jmp RESET
  jmp RETI
  jmp RETI
  jmp RETI
  jmp RETI

  jmp RETI
  jmp RETI
  jmp RETI
  jmp RETI
  jmp RETI

  jmp RETI
  jmp RETI
  jmp RETI
  jmp RETI
  jmp RETI

  jmp RETI
  jmp RETI
  jmp RETI
  jmp RETI
  jmp RETI

  jmp RETI


RETI:
  reti


RESET:
  ldi TL,low(MAXRAM)
  ldi TH,high(MAXRAM)
  out SPL,TL
  out SPH,TH
  sei

DDR:
  ldi TL,(1<<PINTXD)
  out DDRD,TL

COLOURS:
  .def RED = R16
  .def GRN = R17
  ldi RED,(1<<PINTXD) ; pin = 1, RS232 = -12V, LED = red
  mov GRN,RED
  com GRN             ; pin = 0, RS232 = 12V, LED = green

INIT:
  in TL,PORTD
  or TL,RED
  out PORTD,TL

LOOP:
G1:
  in TL,PORTD
  and TL,GRN      ; blink
  out PORTD,TL

  call WAIT

R1:
  in TL,PORTD
  or TL,RED       ; break
  out PORTD,TL

  call WAIT

G2:
  in TL,PORTD
  and TL,GRN      ; blink
  out PORTD,TL

  call WAIT

R2:
  in TL,PORTD
  or TL,RED       ; wait
  out PORTD,TL

  call WAIT
  call WAIT
  call WAIT
  call WAIT
  call WAIT

  jmp LOOP


WAIT:

  ldi AL,30   ; 30 * 10.7ms = 0.321s
WLOOP3:
  ldi TH,0    ; 256 * 41.8us = 10.7ms
WLOOP2:
  ldi TL,0    ; 1 + 255 * 3 + 2 = 768 clocks = 41.8us @ 18.342MHz
WLOOP1:
  dec TL      ; 1 clock
  brne WLOOP1 ; 2 clocks when taken, 1 when not
  dec TH
  brne WLOOP2
  dec AL
  brne WLOOP3

  ret
