; vga_text_specials.inc - specials for colouring VGA text
; author Neil Franklin, last modification 2008.11.15

  ; full maximal possible 5 character specials
  ;   pre-ASCII char codes 0x0B to 0x0F
  ; start with least important, easiest to sacrifice as first
  .equ ALT3  = 0x09 ; use alternate colour 3
  .equ ALT2  = 0x0A ; use alternate colour 2
  .equ ALT1  = 0x0B ; use alternate colour 1
  .equ ULON  = 0x0C ; underline on
  .equ ULOFF = 0x0D ; underline off, needs this else space still underlined
  .equ INON  = 0x0E ; invert/reverse on
  .equ INOFF = 0x0F ; invert/reverse off, needs this else space still inverted


  ; CHAR special alternate3 0x09

  out PORTC,LUTBACK    ; {1}  like any space set to all background
                       ; {-3} special: 3clk saved from 3  out  used for special
  mov TEMP,LUTFORE     ; {1}  alternative colour 3: swap fore and alt3 colours
  mov LUTFORE,LUTALT3  ; {1}
  mov LUTALT3,TEMP     ; {1}
  ld ZL,X+             ; {8}  standard: next char, without  out  as in space
  mov ZH,ZL
  andi ZH,0x3F
  andi ZL,0x80
  ori ZL,0x00
  ijmp
  .db "012345678901"   ; fill/overjump unused space, 16-10 = 6words|12bytes

  out PORTC,LUTBACK
  mov TEMP,LUTFORE
  mov LUTFORE,LUTALT3
  mov LUTALT3,TEMP
  ld ZL,X+
  mov ZH,ZL
  andi ZH,0x3F
  andi ZL,0x80
  ori ZL,0x10
  ijmp
  .db "012345678901"
 
  out PORTC,LUTBACK
  mov TEMP,LUTFORE
  mov LUTFORE,LUTALT3
  mov LUTALT3,TEMP
  ld ZL,X+
  mov ZH,ZL
  andi ZH,0x3F
  andi ZL,0x80
  ori ZL,0x20
  ijmp
  .db "012345678901"

  out PORTC,LUTBACK
  mov TEMP,LUTFORE
  mov LUTFORE,LUTALT3
  mov LUTALT3,TEMP
  ld ZL,X+
  mov ZH,ZL
  andi ZH,0x3F
  andi ZL,0x80
  ori ZL,0x30
  ijmp
  .db "012345678901"

  out PORTC,LUTBACK
  mov TEMP,LUTFORE
  mov LUTFORE,LUTALT3
  mov LUTALT3,TEMP
  ld ZL,X+
  mov ZH,ZL
  andi ZH,0x3F
  andi ZL,0x80
  ori ZL,0x40
  ijmp
  .db "012345678901"

  out PORTC,LUTBACK
  mov TEMP,LUTFORE
  mov LUTFORE,LUTALT3
  mov LUTALT3,TEMP
  ld ZL,X+
  mov ZH,ZL
  andi ZH,0x3F
  andi ZL,0x80
  ori ZL,0x50
  ijmp
  .db "012345678901"

  out PORTC,LUTBACK
  mov TEMP,LUTFORE
  mov LUTFORE,LUTALT3
  mov LUTALT3,TEMP
  ld ZL,X+
  mov ZH,ZL
  andi ZH,0x3F
  andi ZL,0x80
  ori ZL,0x60
  ijmp
  .db "012345678901"

  out PORTC,LUTBACK
  mov TEMP,LUTFORE
  mov LUTFORE,LUTALT3
  mov LUTALT3,TEMP
  ld ZL,X+
  mov ZH,ZL
  andi ZH,0x3F
  andi ZL,0x80
  ori ZL,0x70
  ijmp
  .db "012345678901"


  ; CHAR special alternate2 0x0A

  out PORTC,LUTBACK    ; {1}  like any space set to all background
                       ; {-3} special: 3clk saved from 3  out  used for special
  mov TEMP,LUTFORE     ; {1}  alternative colour 2: swap fore and alt2 colours
  mov LUTFORE,LUTALT2  ; {1}
  mov LUTALT2,TEMP     ; {1}
  ld ZL,X+             ; {8}  standard: next char, without  out  as in space
  mov ZH,ZL
  andi ZH,0x3F
  andi ZL,0x80
  ori ZL,0x00
  ijmp
  .db "012345678901"   ; fill/overjump unused space, 16-10 = 6words|12bytes

  out PORTC,LUTBACK
  mov TEMP,LUTFORE
  mov LUTFORE,LUTALT2
  mov LUTALT2,TEMP
  ld ZL,X+
  mov ZH,ZL
  andi ZH,0x3F
  andi ZL,0x80
  ori ZL,0x10
  ijmp
  .db "012345678901"

  out PORTC,LUTBACK
  mov TEMP,LUTFORE
  mov LUTFORE,LUTALT2
  mov LUTALT2,TEMP
  ld ZL,X+
  mov ZH,ZL
  andi ZH,0x3F
  andi ZL,0x80
  ori ZL,0x20
  ijmp
  .db "012345678901"

  out PORTC,LUTBACK
  mov TEMP,LUTFORE
  mov LUTFORE,LUTALT2
  mov LUTALT2,TEMP
  ld ZL,X+
  mov ZH,ZL
  andi ZH,0x3F
  andi ZL,0x80
  ori ZL,0x30
  ijmp
  .db "012345678901"

  out PORTC,LUTBACK
  mov TEMP,LUTFORE
  mov LUTFORE,LUTALT2
  mov LUTALT2,TEMP
  ld ZL,X+
  mov ZH,ZL
  andi ZH,0x3F
  andi ZL,0x80
  ori ZL,0x40
  ijmp
  .db "012345678901"

  out PORTC,LUTBACK
  mov TEMP,LUTFORE
  mov LUTFORE,LUTALT2
  mov LUTALT2,TEMP
  ld ZL,X+
  mov ZH,ZL
  andi ZH,0x3F
  andi ZL,0x80
  ori ZL,0x50
  ijmp
  .db "012345678901"

  out PORTC,LUTBACK
  mov TEMP,LUTFORE
  mov LUTFORE,LUTALT2
  mov LUTALT2,TEMP
  ld ZL,X+
  mov ZH,ZL
  andi ZH,0x3F
  andi ZL,0x80
  ori ZL,0x60
  ijmp
  .db "012345678901"

  out PORTC,LUTBACK
  mov TEMP,LUTFORE
  mov LUTFORE,LUTALT2
  mov LUTALT2,TEMP
  ld ZL,X+
  mov ZH,ZL
  andi ZH,0x3F
  andi ZL,0x80
  ori ZL,0x70
  ijmp
  .db "012345678901"


  ; CHAR special alternate1 0x0B

  out PORTC,LUTBACK    ; {1}  like any space set to all background
                       ; {-3} special: 3clk saved from 3  out  used for special
  mov TEMP,LUTFORE     ; {1}  alternative colour 1: swap fore and alt1 colours
  mov LUTFORE,LUTALT1  ; {1}
  mov LUTALT1,TEMP     ; {1}
  ld ZL,X+             ; {8}  standard: next char, without  out  as in space
  mov ZH,ZL
  andi ZH,0x3F
  andi ZL,0x80
  ori ZL,0x00
  ijmp
  .db "012345678901"   ; fill/overjump unused space, 16-10 = 6words|12bytes

  out PORTC,LUTBACK
  mov TEMP,LUTFORE
  mov LUTFORE,LUTALT1
  mov LUTALT1,TEMP
  ld ZL,X+
  mov ZH,ZL
  andi ZH,0x3F
  andi ZL,0x80
  ori ZL,0x10
  ijmp
  .db "012345678901"

  out PORTC,LUTBACK
  mov TEMP,LUTFORE
  mov LUTFORE,LUTALT1
  mov LUTALT1,TEMP
  ld ZL,X+
  mov ZH,ZL
  andi ZH,0x3F
  andi ZL,0x80
  ori ZL,0x20
  ijmp
  .db "012345678901"

  out PORTC,LUTBACK
  mov TEMP,LUTFORE
  mov LUTFORE,LUTALT1
  mov LUTALT1,TEMP
  ld ZL,X+
  mov ZH,ZL
  andi ZH,0x3F
  andi ZL,0x80
  ori ZL,0x30
  ijmp
  .db "012345678901"

  out PORTC,LUTBACK
  mov TEMP,LUTFORE
  mov LUTFORE,LUTALT1
  mov LUTALT1,TEMP
  ld ZL,X+
  mov ZH,ZL
  andi ZH,0x3F
  andi ZL,0x80
  ori ZL,0x40
  ijmp
  .db "012345678901"

  out PORTC,LUTBACK
  mov TEMP,LUTFORE
  mov LUTFORE,LUTALT1
  mov LUTALT1,TEMP
  ld ZL,X+
  mov ZH,ZL
  andi ZH,0x3F
  andi ZL,0x80
  ori ZL,0x50
  ijmp
  .db "012345678901"

  out PORTC,LUTBACK
  mov TEMP,LUTFORE
  mov LUTFORE,LUTALT1
  mov LUTALT1,TEMP
  ld ZL,X+
  mov ZH,ZL
  andi ZH,0x3F
  andi ZL,0x80
  ori ZL,0x60
  ijmp
  .db "012345678901"

  out PORTC,LUTBACK
  mov TEMP,LUTFORE
  mov LUTFORE,LUTALT1
  mov LUTALT1,TEMP
  ld ZL,X+
  mov ZH,ZL
  andi ZH,0x3F
  andi ZL,0x80
  ori ZL,0x70
  ijmp
  .db "012345678901"


  ; CHAR special underline on 0x0C

  out PORTC,LUTBACK    ; {1}  like any space set to all background
                       ; {-3} special: 3clk saved from 3  out  used for special
  nop                  ; {1}  underlined: lines 0..6 do nothing, line 7 below
  nop                  ; {1}
  nop                  ; {1}
  ld ZL,X+             ; {8}  standard: next char, without  out  as in space
  mov ZH,ZL
  andi ZH,0x3F
  andi ZL,0x80
  ori ZL,0x00
  ijmp
  .db "012345678901"   ; fill/overjump unused space, 16-10 = 6words|12bytes

  out PORTC,LUTBACK
  nop
  nop
  nop
  ld ZL,X+
  mov ZH,ZL
  andi ZH,0x3F
  andi ZL,0x80
  ori ZL,0x10
  ijmp
  .db "012345678901"

  out PORTC,LUTBACK
  nop
  nop
  nop
  ld ZL,X+
  mov ZH,ZL
  andi ZH,0x3F
  andi ZL,0x80
  ori ZL,0x20
  ijmp
  .db "012345678901"

  out PORTC,LUTBACK
  nop
  nop
  nop
  ld ZL,X+
  mov ZH,ZL
  andi ZH,0x3F
  andi ZL,0x80
  ori ZL,0x30
  ijmp
  .db "012345678901"

  out PORTC,LUTBACK
  nop
  nop
  nop
  ld ZL,X+
  mov ZH,ZL
  andi ZH,0x3F
  andi ZL,0x80
  ori ZL,0x40
  ijmp
  .db "012345678901"

  out PORTC,LUTBACK
  nop
  nop
  nop
  ld ZL,X+
  mov ZH,ZL
  andi ZH,0x3F
  andi ZL,0x80
  ori ZL,0x50
  ijmp
  .db "012345678901"

  out PORTC,LUTBACK
  nop
  nop
  nop
  ld ZL,X+
  mov ZH,ZL
  andi ZH,0x3F
  andi ZL,0x80
  ori ZL,0x60
  ijmp
  .db "012345678901"

  out PORTC,LUTBACK
  mov TEMP,LUTFORE     ; {1}  underlined: line 7 fore/back invert
  mov LUTFORE,LUTBACK  ; {1}
  mov LUTBACK,TEMP     ; {1}
  ld ZL,X+
  mov ZH,ZL
  andi ZH,0x3F
  andi ZL,0x80
  ori ZL,0x70
  ijmp
  .db "012345678901"


  ; CHAR special underline off 0x0D

  out PORTC,LUTBACK    ; {1}  like any space set to all background
                       ; {-3} special: 3clk saved from 3  out  used for special
  nop                  ; {1}  underlined: lines 0..6 do nothing, line 7 below
  nop                  ; {1}
  nop                  ; {1}
  ld ZL,X+             ; {8}  standard: next char, without  out  as in space
  mov ZH,ZL
  andi ZH,0x3F
  andi ZL,0x80
  ori ZL,0x00
  ijmp
  .db "012345678901"   ; fill/overjump unused space, 16-10 = 6words|12bytes

  out PORTC,LUTBACK
  nop
  nop
  nop
  ld ZL,X+
  mov ZH,ZL
  andi ZH,0x3F
  andi ZL,0x80
  ori ZL,0x10
  ijmp
  .db "012345678901"

  out PORTC,LUTBACK
  nop
  nop
  nop
  ld ZL,X+
  mov ZH,ZL
  andi ZH,0x3F
  andi ZL,0x80
  ori ZL,0x20
  ijmp
  .db "012345678901"

  out PORTC,LUTBACK
  nop
  nop
  nop
  ld ZL,X+
  mov ZH,ZL
  andi ZH,0x3F
  andi ZL,0x80
  ori ZL,0x30
  ijmp
  .db "012345678901"

  out PORTC,LUTBACK
  nop
  nop
  nop
  ld ZL,X+
  mov ZH,ZL
  andi ZH,0x3F
  andi ZL,0x80
  ori ZL,0x40
  ijmp
  .db "012345678901"

  out PORTC,LUTBACK
  nop
  nop
  nop
  ld ZL,X+
  mov ZH,ZL
  andi ZH,0x3F
  andi ZL,0x80
  ori ZL,0x50
  ijmp
  .db "012345678901"

  out PORTC,LUTBACK
  nop
  nop
  nop
  ld ZL,X+
  mov ZH,ZL
  andi ZH,0x3F
  andi ZL,0x80
  ori ZL,0x60
  ijmp
  .db "012345678901"

  out PORTC,LUTFORE
  mov TEMP,LUTFORE     ; {1}  underlined: line 7 fore/back invert
  mov LUTFORE,LUTBACK  ; {1}
  mov LUTBACK,TEMP     ; {1}
  ld ZL,X+
  mov ZH,ZL
  andi ZH,0x3F
  andi ZL,0x80
  ori ZL,0x70
  ijmp
  .db "012345678901"


  ; CHAR special invert on 0x0E

  out PORTC,LUTBACK    ; {1}  like any space set to all background
                       ; {-3} special: 3clk saved from 3  out  used for special
  mov TEMP,LUTFORE     ; {1}  inverted display: swap fore and back colours
  mov LUTFORE,LUTBACK  ; {1}
  mov LUTBACK,TEMP     ; {1}
  ld ZL,X+             ; {8}  standard: next char, without  out  as in space
  mov ZH,ZL
  andi ZH,0x3F
  andi ZL,0x80
  ori ZL,0x00
  ijmp
  .db "012345678901"   ; fill/overjump unused space, 16-10 = 6words|12bytes

  out PORTC,LUTBACK
  mov TEMP,LUTFORE
  mov LUTFORE,LUTBACK
  mov LUTBACK,TEMP
  ld ZL,X+
  mov ZH,ZL
  andi ZH,0x3F
  andi ZL,0x80
  ori ZL,0x10
  ijmp
  .db "012345678901"

  out PORTC,LUTBACK
  mov TEMP,LUTFORE
  mov LUTFORE,LUTBACK
  mov LUTBACK,TEMP
  ld ZL,X+
  mov ZH,ZL
  andi ZH,0x3F
  andi ZL,0x80
  ori ZL,0x20
  ijmp
  .db "012345678901"

  out PORTC,LUTBACK
  mov TEMP,LUTFORE
  mov LUTFORE,LUTBACK
  mov LUTBACK,TEMP
  ld ZL,X+
  mov ZH,ZL
  andi ZH,0x3F
  andi ZL,0x80
  ori ZL,0x30
  ijmp
  .db "012345678901"

  out PORTC,LUTBACK
  mov TEMP,LUTFORE
  mov LUTFORE,LUTBACK
  mov LUTBACK,TEMP
  ld ZL,X+
  mov ZH,ZL
  andi ZH,0x3F
  andi ZL,0x80
  ori ZL,0x40
  ijmp
  .db "012345678901"

  out PORTC,LUTBACK
  mov TEMP,LUTFORE
  mov LUTFORE,LUTBACK
  mov LUTBACK,TEMP
  ld ZL,X+
  mov ZH,ZL
  andi ZH,0x3F
  andi ZL,0x80
  ori ZL,0x50
  ijmp
  .db "012345678901"

  out PORTC,LUTBACK
  mov TEMP,LUTFORE
  mov LUTFORE,LUTBACK
  mov LUTBACK,TEMP
  ld ZL,X+
  mov ZH,ZL
  andi ZH,0x3F
  andi ZL,0x80
  ori ZL,0x60
  ijmp
  .db "012345678901"

  out PORTC,LUTBACK
  mov TEMP,LUTFORE
  mov LUTFORE,LUTBACK
  mov LUTBACK,TEMP
  ld ZL,X+
  mov ZH,ZL
  andi ZH,0x3F
  andi ZL,0x80
  ori ZL,0x70
  ijmp
  .db "012345678901"


  ; CHAR special invert off 0x0F

  out PORTC,LUTFORE    ; {1}  like any space set to all background
                       ; {-3} special: 3clk saved from 3  out  used for special
  mov TEMP,LUTFORE     ; {1}  inverted display: swap fore and back colours
  mov LUTFORE,LUTBACK  ; {1}
  mov LUTBACK,TEMP     ; {1}
  ld ZL,X+             ; {8}  standard: next char, without  out  as in space
  mov ZH,ZL
  andi ZH,0x3F
  andi ZL,0x80
  ori ZL,0x00
  ijmp
  .db "012345678901"   ; fill/overjump unused space, 16-10 = 6words|12bytes

  out PORTC,LUTFORE
  mov TEMP,LUTFORE
  mov LUTFORE,LUTBACK
  mov LUTBACK,TEMP
  ld ZL,X+
  mov ZH,ZL
  andi ZH,0x3F
  andi ZL,0x80
  ori ZL,0x10
  ijmp
  .db "012345678901"

  out PORTC,LUTFORE
  mov TEMP,LUTFORE
  mov LUTFORE,LUTBACK
  mov LUTBACK,TEMP
  ld ZL,X+
  mov ZH,ZL
  andi ZH,0x3F
  andi ZL,0x80
  ori ZL,0x20
  ijmp
  .db "012345678901"

  out PORTC,LUTFORE
  mov TEMP,LUTFORE
  mov LUTFORE,LUTBACK
  mov LUTBACK,TEMP
  ld ZL,X+
  mov ZH,ZL
  andi ZH,0x3F
  andi ZL,0x80
  ori ZL,0x30
  ijmp
  .db "012345678901"

  out PORTC,LUTFORE
  mov TEMP,LUTFORE
  mov LUTFORE,LUTBACK
  mov LUTBACK,TEMP
  ld ZL,X+
  mov ZH,ZL
  andi ZH,0x3F
  andi ZL,0x80
  ori ZL,0x40
  ijmp
  .db "012345678901"

  out PORTC,LUTFORE
  mov TEMP,LUTFORE
  mov LUTFORE,LUTBACK
  mov LUTBACK,TEMP
  ld ZL,X+
  mov ZH,ZL
  andi ZH,0x3F
  andi ZL,0x80
  ori ZL,0x50
  ijmp
  .db "012345678901"

  out PORTC,LUTFORE
  mov TEMP,LUTFORE
  mov LUTFORE,LUTBACK
  mov LUTBACK,TEMP
  ld ZL,X+
  mov ZH,ZL
  andi ZH,0x3F
  andi ZL,0x80
  ori ZL,0x60
  ijmp
  .db "012345678901"

  out PORTC,LUTFORE
  mov TEMP,LUTFORE
  mov LUTFORE,LUTBACK
  mov LUTBACK,TEMP
  ld ZL,X+
  mov ZH,ZL
  andi ZH,0x3F
  andi ZL,0x80
  ori ZL,0x70
  ijmp
  .db "012345678901"
